import type { ParserRuleContext, Token } from 'antlr4';
import { LocationI } from '@cashscript/utils';
export declare class Location implements LocationI {
    start: Point;
    end: Point;
    constructor(start: Point, end: Point);
    static fromCtx(ctx: ParserRuleContext): Location;
    static fromToken(token: Token): Location;
    static fromObject(object: LocationI): Location;
    text(code: string): string;
}
export declare class Point {
    line: number;
    column: number;
    constructor(line: number, column: number);
    offset(code: string): number;
    toString(): string;
}
