import { ErrorListener, RecognitionException, Recognizer } from 'antlr4';
/**
 * ANTLR Error Listener that immediately throws on error. This is used so that
 * ANTLR doesn't attempt any error recovery during lexing/parsing and fails early.
 */
export default class ThrowingErrorListener<TSymbol> extends ErrorListener<TSymbol> {
    static readonly INSTANCE: ThrowingErrorListener<unknown>;
    syntaxError(recognizer: Recognizer<TSymbol>, offendingSymbol: TSymbol, line: number, charPositionInLine: number, message: string, e?: RecognitionException): void;
}
