import { Script, LogEntry, RequireStatement, StackItem } from '@cashscript/utils';
import { ContractNode, ParameterNode, VariableDefinitionNode, FunctionDefinitionNode, AssignNode, IdentifierNode, BranchNode, CastNode, FunctionCallNode, UnaryOpNode, BinaryOpNode, BoolLiteralNode, IntLiteralNode, HexLiteralNode, StringLiteralNode, TimeOpNode, ArrayNode, TupleIndexOpNode, RequireNode, SourceFileNode, Node, InstantiationNode, TupleAssignmentNode, NullaryOpNode, ConsoleStatementNode } from '../ast/AST.js';
import AstTraversal from '../ast/AstTraversal.js';
export default class GenerateTargetTraversalWithLocation extends AstTraversal {
    private locationData;
    sourceMap: string;
    output: Script;
    stack: string[];
    consoleLogs: LogEntry[];
    requires: RequireStatement[];
    finalStackUsage: Record<string, StackItem>;
    private scopeDepth;
    private currentFunction;
    private constructorParameterCount;
    private emit;
    private pushToStack;
    private popFromStack;
    private removeFromStack;
    private nipFromStack;
    private getStackIndex;
    private getMostRecentInstructionPointer;
    visitSourceFile(node: SourceFileNode): Node;
    visitContract(node: ContractNode): Node;
    visitFunctionDefinition(node: FunctionDefinitionNode): Node;
    removeFinalVerifyFromFunction(functionBodyNode: Node): void;
    cleanStack(functionBodyNode: Node): void;
    visitParameter(node: ParameterNode): Node;
    visitVariableDefinition(node: VariableDefinitionNode): Node;
    visitTupleAssignment(node: TupleAssignmentNode): Node;
    visitAssign(node: AssignNode): Node;
    emitReplace(index: number, node: Node): void;
    visitTimeOp(node: TimeOpNode): Node;
    visitRequire(node: RequireNode): Node;
    visitConsoleStatement(node: ConsoleStatementNode): Node;
    visitBranch(node: BranchNode): Node;
    removeScopedVariables(depthBeforeScope: number, node: Node): void;
    visitCast(node: CastNode): Node;
    visitFunctionCall(node: FunctionCallNode): Node;
    visitMultiSig(node: FunctionCallNode): Node;
    visitInstantiation(node: InstantiationNode): Node;
    visitTupleIndexOp(node: TupleIndexOpNode): Node;
    visitBinaryOp(node: BinaryOpNode): Node;
    visitUnaryOp(node: UnaryOpNode): Node;
    visitNullaryOp(node: NullaryOpNode): Node;
    visitArray(node: ArrayNode): Node;
    visitIdentifier(node: IdentifierNode): Node;
    isOpRoll(node: IdentifierNode): boolean;
    visitBoolLiteral(node: BoolLiteralNode): Node;
    visitIntLiteral(node: IntLiteralNode): Node;
    visitStringLiteral(node: StringLiteralNode): Node;
    visitHexLiteral(node: HexLiteralNode): Node;
}
